import java.awt.*;
import java.awt.event.*;
import java.io.*;

class OpenGL {
	public static int GL_NEVER = 0x0200;
	public static int GL_LESS = 0x0201;
	public static int GL_EQUAL = 0x0202;
	public static int GL_LEQUAL = 0x0203;
	public static int GL_GREATER = 0x0204;
	public static int GL_NOTEQUAL = 0x0205;
	public static int GL_GEQUAL = 0x0206;
	public static int GL_ALWAYS = 0x0207;
	public static int GL_DEPTH_BUFFER_BIT = 0x00000100;
	public static int GL_COLOR_BUFFER_BIT = 0x00004000;
	public static int GL_POINTS = 0x0000;
	public static int GL_LINES = 0x0001;
	public static int GL_LINE_LOOP = 0x0002;
	public static int GL_LINE_STRIP = 0x0003;
	public static int GL_TRIANGLES = 0x0004;
	public static int GL_TRIANGLE_STRIP = 0x0005;
	public static int GL_TRIANGLE_FAN = 0x0006;
	public static int GL_QUADS = 0x0007;
	public static int GL_QUAD_STRIP = 0x0008;
	public static int GL_POLYGON = 0x0009;
	public static int GL_ZERO = 0;
	public static int GL_ONE = 1;
	public static int GL_SRC_COLOR = 0x0300;
	public static int GL_ONE_MINUS_SRC_COLOR = 0x0301;
	public static int GL_SRC_ALPHA = 0x0302;
	public static int GL_ONE_MINUS_SRC_ALPHA = 0x0303;
	public static int GL_DST_ALPHA = 0x0304;
	public static int GL_ONE_MINUS_DST_ALPHA = 0x0305;
	public static int GL_TRUE = 1;
	public static int GL_FALSE = 0;
	public static int GL_FRONT = 0x0404;
	public static int GL_BACK = 0x0405;
	public static int GL_FRONT_AND_BACK = 0x0408;	
	public static int GL_EXP = 0x0800;
	public static int GL_EXP2 = 0x0801;
	public static int GL_CW = 0x0900;
	public static int GL_CCW = 0x0901;
	public static int GL_POLYGON_MODE = 0x0B40;
	public static int GL_POLYGON_SMOOTH = 0x0B41;
	public static int GL_CULL_FACE = 0x0B44;
	public static int GL_FRONT_FACE = 0x0B46;
	public static int GL_LIGHTING = 0x0B50;
	public static int GL_LIGHT_MODEL_LOCAL_VIEWER = 0x0B51;
	public static int GL_LIGHT_MODEL_AMBIENT = 0x0B53;
	public static int GL_SHADE_MODEL = 0x0B54;
	public static int GL_FOG = 0x0B60;
	public static int GL_FOG_INDEX = 0x0B61;
	public static int GL_FOG_DENSITY = 0x0B62;
	public static int GL_FOG_START = 0x0B63;
	public static int GL_FOG_END = 0x0B64;
	public static int GL_FOG_MODE = 0x0B65;
	public static int GL_FOG_COLOR = 0x0B66;
	public static int GL_DEPTH_RANGE = 0x0B70;
	public static int GL_DEPTH_TEST = 0x0B71;
	public static int GL_DEPTH_CLEAR_VALUE = 0x0B73;
	public static int GL_DEPTH_FUNC = 0x0B74;
	public static int GL_NORMALIZE = 0x0BA1;
	public static int GL_VIEWPORT = 0x0BA2;
	public static int GL_BLEND = 0x0BE2;
	public static int GL_TEXTURE_1D = 0x0DE0;
	public static int GL_TEXTURE_2D = 0x0DE1;
	public static int GL_DONT_CARE = 0x1100;
	public static int GL_FASTEST = 0x1101;
	public static int GL_NICEST = 0x1102;
	public static int GL_LIGHT0 = 0x4000;
	public static int GL_LIGHT1 = 0x4001;
	public static int GL_LIGHT2 = 0x4002;
	public static int GL_LIGHT3 = 0x4003;
	public static int GL_LIGHT4 = 0x4004;
	public static int GL_LIGHT5 = 0x4005;
	public static int GL_LIGHT6 = 0x4006;
	public static int GL_LIGHT7 = 0x4007;
	public static int GL_AMBIENT = 0x1200;
	public static int GL_DIFFUSE = 0x1201;
	public static int GL_SPECULAR = 0x1202;
	public static int GL_POSITION = 0x1203;
	public static int GL_SPOT_DIRECTION = 0x1204;
	public static int GL_SPOT_EXPONENT = 0x1205;
	public static int GL_SPOT_CUTOFF = 0x1206;
	public static int GL_CONSTANT_ATTENUATION = 0x1207;
	public static int GL_LINEAR_ATTENUATION = 0x1208;
	public static int GL_QUADRATIC_ATTENUATION = 0x1209;
	public static int GL_COMPILE = 0x1300;
	public static int GL_COMPILE_AND_EXECUTE = 0x1301;
	public static int GL_MODELVIEW = 0x1700;
	public static int GL_PROJECTION = 0x1701;
	public static int GL_TEXTURE = 0x1702;
	public static int GL_COLOR_INDEX = 0x1900;
	public static int GL_STENCIL_INDEX = 0x1901;
	public static int GL_DEPTH_COMPONENT = 0x1902;
	public static int GL_RED = 0x1903;
	public static int GL_GREEN = 0x1904;
	public static int GL_BLUE = 0x1905;
	public static int GL_ALPHA = 0x1906;
	public static int GL_RGB = 0x1907;
	public static int GL_RGBA = 0x1908;
	public static int GL_LUMINANCE = 0x1909;
	public static int GL_LUMINANCE_ALPHA = 0x190A;
	public static int GL_POINT = 0x1B00;
	public static int GL_LINE = 0x1B01;
	public static int GL_FILL = 0x1B02;
	public static int GL_FLAT = 0x1D00;
	public static int GL_SMOOTH = 0x1D01;
	public static int GL_NEAREST = 0x2600;
	public static int GL_LINEAR = 0x2601;
	public static int GL_CLAMP = 0x2900;
	public static int GL_REPEAT = 0x2901;
	public static int GL_TEXTURE_WRAP_S = 0x2802;
	public static int GL_TEXTURE_WRAP_T = 0x2803;
	public static int GL_TEXTURE_MAG_FILTER = 0x2800;
	public static int GL_TEXTURE_MIN_FILTER = 0x2801;
	public static int GL_PERSPECTIVE_CORRECTION_HINT = 0x0C50;
	
	static
	{
		try
		{
			System.loadLibrary("opengl");
		}
		catch (UnsatisfiedLinkError e)
		{
			System.out.println("Cannot load library OPENGL.DLL");
			System.exit(-1);
		}
	}
	public native void glAlphaFunc(int func, float ref);
	public native void glBegin(int mode);
	public native void glBlendFunc(int sfactor, int dfactor);
	public native void glCallList(int list);
	public native void glClear(int mask);
	public native void glClearColor(float red, float green, float blue, float alpha);
	public native void glColor3b(byte red, byte green, byte blue);
	public native void glColor3d(double red, double green, double blue);
	public native void glColor3f(float red, float green, float blue);
	public native void glColor3i(int red, int green, int blue);
	public native void glColor3s(short red, short green, short blue);
	public native void glColor4b(byte red, byte green, byte blue, byte alpha);
	public native void glColor4d(double red, double green, double blue, double alpha);
	public native void glColor4f(float red, float green, float blue, float alpha);
	public native void glColor4i(int red, int green, int blue, int alpha);
	public native void glColor4s(short red, short green, short blue, short alpha);
	public native void glColorMask(byte red, byte green, byte blue, byte alpha);
	public native void glColorMaterial(int face, int mode);
	public native void glCullFace(int mode);
	public native void glDeleteLists(int list, int range);
	public native void glDepthFunc(int func);
	public native void glDisable(int cap);
	public native void glEnable(int cap);
	public native void glEnd();
	public native void glFinish();
	public native void glFlush();
	public native void glFogf(int pname, float param);
	public native void glFogi(int pname, int param);
	public native void glFrontFace(int mode);
	public native int glGenLists(int range);
	public native int glGetError();
	public native void glHint(int target, int mode);
	public native void glLightModelf(int pname, float param);
	public native void glLightModeli(int pname, int param);
	public native void glLightf(int light, int pname, float param);
	public native void glLighti(int light, int pname, int param);
	public native void glLoadIdentity();
	public native void glMaterialf(int face, int pname, float param);
	public native void glMateriali(int face, int pname, int param);
	public native void glMatrixMode(int mode);
	public native void glNewList(int list, int mode);
	public native void glNormal3b(byte nx, byte ny, byte nz);
	public native void glNormal3d(double nx, double ny, double nz);
	public native void glNormal3f(float nx, float ny, float nz);
	public native void glNormal3i(int nx, int ny, int nz);
	public native void glNormal3s(short nx, short ny, short nz);
	public native void glPolygonMode(int face, int mode);
	public native void glPopMatrix();
	public native void glPushMatrix();
	public native void glRotated(double angle, double x, double y, double z);
	public native void glRotatef(float angle, float x, float y, float z);
	public native void glScaled(double x, double y, double z);
	public native void glScalef(float x, float y, float z);
	public native void glScissor(int x, int y, int width, int height);
	public native void glShadeModel(int mode);
	public native void glTexCoord1d(double s);
	public native void glTexCoord1f(float s);
	public native void glTexCoord1i(int s);
	public native void glTexCoord1s(short s);
	public native void glTexCoord2d(double s, double t);
	public native void glTexCoord2f(float s, float t);
	public native void glTexCoord2i(int s, int t);
	public native void glTexCoord2s(short s, short t);
	public native void glTexCoord3d(double s, double t, double r);
	public native void glTexCoord3f(float s, float t, float r);
	public native void glTexCoord3i(int s, int t, int r);
	public native void glTexCoord3s(short s, short t, short r);
	public native void glTexParameterf(int target, int pname, float param);
	public native void glTexParameteri(int target, int pname, int param);
	public native void glTranslated(double x, double y, double z);
	public native void glTranslatef(float x, float y, float z);
	public native void glVertex2d(double x, double y);
	public native void glVertex2f(float x, float y);
	public native void glVertex2i(int x, int y);
	public native void glVertex2s(short x, short y);
	public native void glVertex3d(double x, double y, double z);
	public native void glVertex3f(float x, float y, float z);
	public native void glVertex3i(int x, int y, int z);
	public native void glVertex3s(short x, short y, short z);
	public native void glViewport(int x, int y, int width, int height);

	public OpenGL()
	{
	}
}

class Util {
	static
	{
		try
		{
			System.loadLibrary("util");
		}
		catch (UnsatisfiedLinkError e)
		{
			System.out.println("Cannot load library UTIL.DLL");
			System.exit(-1);
		}
	}

	public native void CreateOpenGL();
	public native void ReleaseOpenGL();
	public native void SwapBuffers();
	public native void DrawShotGun();
	public native void DrawShot();
	public native void gluPerspective(double fovy, double aspect, double zNear, double zFar);
	
	public Util()
	{
	}
}

class Textures {
	static
	{
		try
		{
			System.loadLibrary("textures");
		}
		catch (UnsatisfiedLinkError e)
		{
			System.out.println("Cannot load a library");
			System.exit(-1);
		}
	}
	native static void LoadTextures();
	native static void DeleteTextures();
	native static void SetActiveTexture(int t);
	public Textures()
	{
	}
}

class LevelMap {
	public static byte Map[];
	public static int Pointers[];
	public static short Sizes[];
	static short N;
	public static byte Polygons[];
	static int M;
	public int pos;
	public static short VisList[];
	public static byte StartPos[];
	short Convert(byte b)
	{
		short s = b;

		if (s < 0)
			s += 256;

		return s;
	}
	public LevelMap(String filename)
	{
		FileInputStream f = null;

		try
		{
			f = new FileInputStream(filename);

			Map = new byte[4096];
			Pointers = new int[4096];
			Sizes = new short[4096];
			
			byte[] buf1 = new byte[16384];
			byte[] buf2 = new byte[8192];
			byte[] buf3 = new byte[2];
			byte[] buf4 = new byte[4];
			byte[] buf5;

			try
			{
				f.read(Map);

				pos = 0;
				for (int i = 0; i < 4096; i++)
					if (Map[i] == 2)
						pos++;

				StartPos = new byte[pos * 2];
				pos = 0;
				for (int i = 0; i < 4096; i++)
					if (Map[i] == 2)
					{
						StartPos[pos] = (byte)(i / 64);
						StartPos[pos + 1] = (byte)(i % 64);
						pos += 2;
					}
				

				f.read(buf1);	                                                                                                                                                   

				for (int i = 0; i < 4096; i++)
					Pointers[i] = Convert(buf1[i * 4 + 3]) * 16777216 + 
					Convert(buf1[i * 4 + 2]) * 65536 + 
					Convert(buf1[i * 4 + 1]) * 256 + 
					Convert(buf1[i * 4]);
									 
				f.read(buf2);
				for (int i = 0; i < 4096; i++)
					Sizes[i] = (short)(Convert(buf2[i * 2 + 1]) * 256 + Convert(buf2[i * 2]));

				f.read(buf3);
					N = (short)(Convert(buf3[1]) * 256 + Convert(buf3[0]));
			
				Polygons = new byte[N * 4];
				f.read(Polygons);

				f.read(buf4);
				M =	Convert(buf4[3]) * 16777216 + 
					Convert(buf4[2]) * 65536 + 
					Convert(buf4[1]) * 256 + 
					Convert(buf4[0]);

				VisList = new short[M];
				buf5 = new byte[M * 2];
				f.read(buf5);
				for (int i = 0; i < M; i++)
					VisList[i] = (short)(Convert(buf5[i * 2 + 1]) * 256 + Convert(buf5[i * 2]));
			
				f.close();
			}
			catch (IOException e)
			{
				System.out.println("Cannot read the file");
				System.exit(-1);
			}
		}
		catch (FileNotFoundException e)
		{
			System.out.println("File" + filename + " not found");
			System.exit(-1);
		}
	}
}

class Player {
	public static double x, y, z;
	public static double shot_time;
	public static double y_angle, z_angle, x_angle;
	public Player(double x1, double y1, double angle1)
	{
		x = x1;
		y = y1;
		z = 0;
		x_angle = 0;
		y_angle = angle1;
		z_angle = 0;
		shot_time = Math.PI * 2;
	}
	public void SetPos(double x1, double y1)
	{
		x = x1;
		y = y1;
	}
	public void MoveX(double x1)
	{
		x += x1;
	}
	public void MoveY(double y1)
	{
		y += y1;
	}
	public void SetZ(double z1)
	{
		z = z1;
	}
	public void RotateY(double a)
	{
		y_angle += a;

		if (x_angle > 360.0)
			x_angle -= 360.0;
		
		if (x_angle < -360.0)
			x_angle += 360.0;
	}			
	public void RotateX(double a)
	{
		x_angle += a;

		if (x_angle > 90.0)
			x_angle = 90.0;
		
		if (x_angle < -90.0)
			x_angle = -90.0;
	}			
}

class Shot {
	double x[], y[], z[], a_x[], a_y[];
	boolean e[];
	LevelMap map;
	public Shot(LevelMap m)
	{
		map = m;

		x = new double[16];
		y = new double[16];
		z = new double[16];
		a_x = new double[16];
		a_y = new double[16];
		e = new boolean[16];

		for (int i = 0; i < 16; i++)
			e[i] = false;
	}
	public void Fire(double px, double py, double pz, double x_a, double y_a)
	{
		for (int i = 0; i < 16; i++)
			if (!e[i])
			{
				x[i] = px;
				y[i] = py;
				z[i] = pz + 0.5;
				a_x[i] = x_a;
				a_y[i] = y_a;
				e[i] = true;
				return;
			}
	}
	public void Move()
	{
		for (int i = 0; i < 16; i++)
		{
			if (e[i])
			{
				double t = Math.cos(a_x[i] * Math.PI / 180.0);
				x[i] += Math.cos((a_y[i] - 90) * Math.PI / 180.0) * 0.8 * t;
				y[i] += Math.sin((a_y[i] - 90) * Math.PI / 180.0) * 0.8 * t;
				z[i] += -Math.sin(a_x[i] * Math.PI / 180.0) * 0.8;

				if (x[i] < 0 || x[i] > 63 || y[i] < 0 || y[i] > 63 || z[i] < 0 || z[i] > 1.5)
					e[i] = false;
				else
				if (map.Map[(int)x[i] * 64 + (int)y[i]] == 1)
					e[i] = false;
			}
		}
	}
	public void Draw()
	{
		Util u = new Util();
		OpenGL gl = new OpenGL();

		for (int i = 0; i < 16; i++)
			if (e[i])
			{
				gl.glPushMatrix();
				gl.glTranslated(x[i], z[i], y[i]);
				u.DrawShot();
				gl.glPopMatrix();
			}
	}
};

class Refresh {
	static LevelMap map;
	static Shot s1, s2;
	public Refresh(LevelMap m, Shot s11, Shot s22)
	{
		map = m;
		s1 = s11;
		s2 = s22;
	}
	public void RefreshScreen(Player p)
	{
		OpenGL g = new OpenGL();
		Util u = new Util();
		Textures t = new Textures();
		int offs1 = (int)p.x * 64 + (int)p.y;
		int offs2 = map.Pointers[offs1] / 2;
		int offs3;
		byte x1, y1, x2, y2;

		g.glMatrixMode(OpenGL.GL_MODELVIEW);
		g.glLoadIdentity();
		g.glEnable(OpenGL.GL_DEPTH_TEST);
		g.glClear(OpenGL.GL_DEPTH_BUFFER_BIT);

		g.glRotated(p.z_angle, 0.0, 0.0, 1.0);
		g.glRotated(p.x_angle, 1.0, 0.0, 0.0);
		g.glRotated(p.y_angle, 0.0, 1.0, 0.0);
		g.glTranslated(-p.x, -0.5 + p.z, -p.y);

		g.glEnable(OpenGL.GL_TEXTURE_2D);
		t.SetActiveTexture(1);

		g.glBegin(OpenGL.GL_QUADS);
			g.glTexCoord1i(0);
			g.glVertex3f(0.0f, 0.0f, 0.0f);
			g.glTexCoord2i(0, 64);
			g.glVertex3f(0.0f, 0.0f, 64.0f);
			g.glTexCoord2i(64, 64);
			g.glVertex3f(64.0f, 0.0f, 64.0f);
			g.glTexCoord2i(64, 0);
			g.glVertex3f(64.0f, 0.0f, 0.0f);
		g.glEnd();

		t.SetActiveTexture(2);

		g.glBegin(OpenGL.GL_QUADS);
			g.glTexCoord1i(0);
			g.glVertex3f(0.0f, 1.5f, 0.0f);
			g.glTexCoord2i(0, 16);
			g.glVertex3f(0.0f, 1.5f, 64.0f);
			g.glTexCoord2i(16, 16);
			g.glVertex3f(64.0f, 1.5f, 64.0f);
			g.glTexCoord2i(16, 0);
			g.glVertex3f(64.0f, 1.5f, 0.0f);
		g.glEnd();

		t.SetActiveTexture(0);
		
		for (int i = 0; i < map.Sizes[offs1]; i++)
		{
			offs3 = map.VisList[offs2];

			x1 = map.Polygons[offs3 * 4];
			y1 = map.Polygons[offs3 * 4 + 1];
			x2 = map.Polygons[offs3 * 4 + 2];
			y2 = map.Polygons[offs3 * 4 + 3];

			if (x2 == x1)
			{
				g.glBegin(OpenGL.GL_QUADS);
					g.glTexCoord2i(0, 1);
					g.glVertex3f(x1, 1.5f, y1);
					g.glTexCoord2i(y2 - y1, 1);
					g.glVertex3f(x2, 1.5f, y2);
					g.glTexCoord2i(y2 - y1, 0);
					g.glVertex3i(x2, 0, y2);
					g.glTexCoord1i(0);
					g.glVertex3i(x1, 0, y1);
				g.glEnd(); 
			}
			else
			{
				g.glBegin(OpenGL.GL_QUADS);
					g.glTexCoord2i(0, 1);
					g.glVertex3f(x1, 1.5f, y1);
					g.glTexCoord2i(x2 - x1, 1);
					g.glVertex3f(x2, 1.5f, y2);
					g.glTexCoord2i(x2 - x1, 0);
					g.glVertex3i(x2, 0, y2);
					g.glTexCoord1i(0);
					g.glVertex3i(x1, 0, y1);
				g.glEnd(); 
			}

			offs2++;
		}

		g.glDisable(OpenGL.GL_TEXTURE_2D);
		
		g.glColor3d(0.0, 0.0, 0.2);
		s1.Draw();
		s2.Draw();
		g.glColor3d(1.0, 1.0, 1.0);

		g.glDisable(OpenGL.GL_DEPTH_TEST);
		g.glLoadIdentity();
		g.glRotated(p.z_angle, 0.0, 0.0, 1.0);
		g.glTranslated(0.0, p.z * 4, 0.0);
		if (p.shot_time < Math.PI)
			g.glTranslated(0.0, 0.0, Math.sin(p.shot_time) * 8);
		u.DrawShotGun();

		u.SwapBuffers();
		g.glFinish();
	}
}

public class World {
	static Util util;
	static LevelMap m;
	static Textures t;
	public static void main(String args[])
	{
		Frame f = new Frame(" ");
		f.setSize(320, 240);
		util = new Util();
		m = new LevelMap("level.map");
		t = new Textures();
		t.LoadTextures();
		TheCanvas c = new TheCanvas(m);
		f.add(c);
		f.show();
		f.addWindowListener(new
			WindowAdapter() 
			{
				public void windowClosing(WindowEvent e)
				{
					util.ReleaseOpenGL();
					t.DeleteTextures();
					System.exit(0);
				}
				public void windowActivated(WindowEvent e)
				{
					util.CreateOpenGL();
				}
			}
		);
	}
}

class TheCanvas extends Canvas {
	static RefreshThread th;
	static Refresh ref;
	static Player p;
	static boolean u, d, l, r, sr, sl, la, ld, s;
	static boolean walk_mode;
	static double walk_pos;
	static Shot s1, s2;
	static LevelMap map;
	TheCanvas(LevelMap m)
	{
		u = d = l = r = sr = sl = la = ld = s = false;
		walk_mode = false;
		map = m;
		p = new Player(m.StartPos[0] + 0.5, m.StartPos[1] + 0.5, 120.0);
		s1 = new Shot(m);
		s2 = new Shot(m);
		ref = new Refresh(m, s1, s2);
		th = new RefreshThread(this);
		th.start();
	}
	public void paint(Graphics gr)
	{
		Dimension d = size();
		OpenGL g = new OpenGL();
		Util u = new Util();

		g.glDepthFunc(OpenGL.GL_LEQUAL);
		g.glTexParameteri(OpenGL.GL_TEXTURE_2D, OpenGL.GL_TEXTURE_WRAP_S, 1);
		g.glTexParameteri(OpenGL.GL_TEXTURE_2D, OpenGL.GL_TEXTURE_WRAP_T, 1);
		g.glTexParameteri(OpenGL.GL_TEXTURE_2D, OpenGL.GL_TEXTURE_MIN_FILTER, OpenGL.GL_NEAREST);
		g.glTexParameteri(OpenGL.GL_TEXTURE_2D, OpenGL.GL_TEXTURE_MAG_FILTER, OpenGL.GL_NEAREST);
		g.glHint(OpenGL.GL_PERSPECTIVE_CORRECTION_HINT, OpenGL.GL_NICEST);

		g.glMatrixMode(OpenGL.GL_PROJECTION);
		g.glLoadIdentity();
		u.gluPerspective(30.0, (float)d.width / (float)d.height, 0.1, 50.0);
		g.glViewport(0, 0, d.width, d.height);

		MovePlayer();

		if (s) Fire();

		if (p.shot_time < Math.PI * 2)
			p.shot_time += 1.0;
		else
			p.shot_time = Math.PI * 2;

		s1.Move();
		s2.Move();
		ref.RefreshScreen(p);
	}
	public void update(Graphics g)
	{
		paint(g);
	}
	void Fire()
	{
		if (p.shot_time < Math.PI * 2) return;

		double x = Math.cos(p.y_angle * Math.PI / 180.0) * 0.05;
		double y = Math.sin(p.y_angle * Math.PI / 180.0) * 0.05;
		
		s1.Fire(p.x + x, p.y + y, p.z, p.x_angle, p.y_angle); 
		s2.Fire(p.x - x, p.y - y, p.z, p.x_angle, p.y_angle); 

		p.shot_time = 0.0;
	}
	void TryMovePlayer(double dx, double dy)
	{
		int x = (int)p.x;
		int y = (int)p.y;
		double x_ = x;
		double y_ = y;
		double dx_ = dx, dy_ = dy;

		byte b1 = map.Map[(x + 1) * 64 + y];
		byte b2 = map.Map[(x - 1) * 64 + y];
		byte b3 = map.Map[x * 64 + y + 1];
		byte b4 = map.Map[x * 64 + y - 1];
		byte b5 = map.Map[(x + 1) * 64 + y - 1];
		byte b6 = map.Map[(x - 1) * 64 + y - 1];
		byte b7 = map.Map[(x - 1) * 64 + y + 1];
		byte b8 = map.Map[(x + 1) * 64 + y + 1];

		if (p.x + dx > x_ + 0.6 && b1 == 1)
			dx_ = x_ + 0.6 - p.x;
		else
		if (p.x + dx < x_ + 0.4 && b2 == 1)
			dx_ = x_ + 0.4 - p.x;
		if (p.y + dy > y_ + 0.6 && b3 == 1)
			dy_ = y_ + 0.6 - p.y;
		else
		if (p.y + dy < y_ + 0.4 && b4 == 1)
			dy_ = y_ + 0.4 - p.y;

		if (b5 == 1)
		{
			if (b4 != 1 && b1 != 1)
			{
				if (x_ + 1 - p.x > p.y - y_)
				{
					if (p.x + dx > x_ + 0.6)
						dx_ = x_ + 0.6 - p.x;
				}
				else
				{
					if (p.y + dy < y_ + 0.4)
						dy_ = y_ + 0.4 - p.y;
				}
			}
		}
		if (b6 == 1)
		{
			if (b4 != 1 && b2 != 1)
			{
				if (p.x - x_ > p.y - y_)
				{
					if (p.x + dx < x_ + 0.4)
						dx_ = x_ + 0.4 - p.x;
				}
				else
				{
					if (p.y + dy < y_ + 0.4)
						dy_ = y_ + 0.4 - p.y;
				}
			}
		}
		if (b7 == 1)
		{
			if (b2 != 1 && b3 != 1)
			{
				if (p.x - x_ > y_ + 1 - p.y)
				{
					if (p.x + dx < x_ + 0.4)
						dx_ = x_ + 0.4 - p.x;
				}
				else
				{
					if (p.y + dy > y_ + 0.6)
						dy_ = y_ + 0.6 - p.y;
				}
			}
		}
		if (b8 == 1)
		{
			if (b3 != 1 && b1 != 1)
			{
				if (x_ + 1 - p.x > y_ + 1 - p.y)
				{
					if (p.x + dx > x_ + 0.6)
						dx_ = x_ + 0.6 - p.x;
				}
				else
				{
					if (p.y + dy > y_ + 0.6)
						dy_ = y_ + 0.6 - p.y;
				}
			}
		}

		p.MoveX(dx_);
		p.MoveY(dy_);
	}
	void MovePlayer()
	{
		double dx = 0, dy = 0;

		if (l) p.RotateY(-5.0); 
		if (r) p.RotateY(5.0); 
		if (la) p.RotateX(-5.0);
		if (ld) p.RotateX(5.0);
		if (u) 
		{
			dx = Math.cos((p.y_angle - 90) * Math.PI / 180.0) * 0.4;
			dy = Math.sin((p.y_angle - 90) * Math.PI / 180.0) * 0.4;
		}
		if (d) 
		{
			dx = -Math.cos((p.y_angle - 90) * Math.PI / 180.0) * 0.4;
			dy = -Math.sin((p.y_angle - 90) * Math.PI / 180.0) * 0.4;
		}
		if (sr)
		{
			dx += Math.cos(p.y_angle * Math.PI / 180.0) * 0.2;
			dy += Math.sin(p.y_angle * Math.PI / 180.0) * 0.2;
		}
		if (sl)
		{
			dx += -Math.cos(p.y_angle * Math.PI / 180.0) * 0.2;
			dy += -Math.sin(p.y_angle * Math.PI / 180.0) * 0.2;
		}

		if (dx != 0 || dy != 0)
		{
			TryMovePlayer(dx, dy);
			p.SetZ(Math.sin(walk_pos) * 0.1);
			walk_pos +=	0.6;

			if (walk_pos > Math.PI * 2)
				walk_pos -=	Math.PI * 2;
		}
	}
	public boolean keyDown(Event e, int key)
	{
		if (key == 27)
		{
			Util u = new Util();
			Textures t = new Textures();

			u.ReleaseOpenGL();
			t.DeleteTextures();
			System.exit(0);
		}
		else
			switch (key)
			{
				case 1004: u = true; d = false; break;
				case 1005: d = true; u = false; break;
				case 1006: l = true; r = false; break;
				case 1007: r = true; l = false; break;
				case 1000: p.x_angle = 0.0; break;
				case 44: sl = true; sr = false; p.z_angle = -3.0; break;
				case 46: sr = true; sl = false; p.z_angle = 3.0; break;
				case 65:
				case 97: la = true; ld = false; break;
				case 90:
				case 122: ld = true; la = false; break;
				case 32: s = true; 
			}

		if (u || d || sl || sr) 
		{
			if (!walk_mode)
				walk_pos = 0.0;
			walk_mode = true;
		}

		return true;
	}
	public boolean keyUp(Event e, int key)
	{				 
		switch (key)
		{
			case 1004: u = false; break;
			case 1005: d = false; break;
			case 1006: l = false; break;
			case 1007: r = false; break;
			case 44: sl = false; p.z_angle = 0.0; break;
			case 46: sr = false; p.z_angle = 0.0; 
			case 65:
			case 97: la = false; break;
			case 90:
			case 122: ld = false; break;
			case 32: s = false;
		}

		if (!u && !d && !sl && !sr) 
		{
			p.SetZ(0.0);
			walk_mode = false;
		}

		return true;
	}
}

class RefreshThread extends Thread {
	static Canvas c;
	RefreshThread(Canvas canvas)
	{
		super();
		c = canvas;
	}
	public void run()
	{
		try
		{
			while (true)
			{
				c.repaint();
				sleep(40);   
			}
		}
		catch (InterruptedException e)
		{
		}
	}

}
