#include <windows.h>
#include <gl/glu.h>
#include <alloc.h>

#define JAVAEXPORT  __declspec(dllexport) __stdcall
#define JENV        void *jenv, void *jclass
#define TEX_SIZE    12228
#define BMP_OFFS	  0x36
#define TEX_WIDTH   64
#define TEX_HEIGHT  64

char **textures;
HANDLE mem;

void JAVAEXPORT Java_Textures_LoadTextures(JENV)
{
   int i = 0;
   char filename[] = "texture_.bmp";
   HANDLE in;
   OFSTRUCT info;
   unsigned long b;

   mem = HeapCreate(HEAP_GENERATE_EXCEPTIONS, 65536, 65536);
   textures = (char **)HeapAlloc(mem, HEAP_GENERATE_EXCEPTIONS, sizeof(char *) * 3);

   for (; i < 3; i++)
   {
     textures[i] = (char *)HeapAlloc(mem, HEAP_GENERATE_EXCEPTIONS, TEX_SIZE);
     filename[7] = i + '1';

     in = (HANDLE)OpenFile(filename, &info, OF_READ);

     ReadFile(in, textures[i], BMP_OFFS, &b, NULL);
     ReadFile(in, textures[i], TEX_SIZE, &b, NULL);
     CloseHandle(in);
   }
}

void JAVAEXPORT Java_Textures_DeleteTextures(JENV)
{
   int i = 0;

   for (; i < 3; i++)
     HeapFree(mem, 0, textures[i]);

   HeapFree(mem, 0, textures);
   HeapDestroy(mem);
}

void JAVAEXPORT Java_Textures_SetActiveTexture(JENV, long tex)
{
  glTexImage2D(GL_TEXTURE_2D, 0, 3, TEX_WIDTH, TEX_HEIGHT, 0, GL_RGB, GL_UNSIGNED_BYTE, textures[tex]);
}

